/*******************************************************************************
 * Copyright (c) 2007, 2015 IBM Corporation and others.
 *
 * This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

package org.eclipse.ui.views.markers;

/**
 * MarkerSupportConstants is a static class that supplies commonly used constants.
 *
 * @since 3.4
 *
 */
public class MarkerSupportConstants {

	/**
	 * The constant used to specify the contains value on
	 * a {@link FiltersContributionParameters}
	 */
	public static final String CONTAINS_KEY = "CONTAINS"; //$NON-NLS-1$

	/**
	 * The constant used to specify the does not contain value on
	 * a {@link FiltersContributionParameters}
	 */
	public static String DOES_NOT_CONTAIN_KEY = "DOES_NOT_CONTAIN"; //$NON-NLS-1$


}
